import { EventClient } from '../event/event-client';
import { DispatcherClient } from '../dispatcher/dispatcher-client';
import { AdminClient } from '../admin/admin-client';
import { Channel, ChannelCredentials } from 'nice-grpc';
import { Workflow } from '../../workflow';
import { Worker } from '../worker';
import Logger from '../../util/logger/logger';
import { ClientConfig } from './client-config';
export interface HatchetClientOptions {
    config_path?: string;
    credentials?: ChannelCredentials;
}
export declare class HatchetClient {
    config: ClientConfig;
    credentials: ChannelCredentials;
    channel: Channel;
    event: EventClient;
    dispatcher: DispatcherClient;
    admin: AdminClient;
    logger: Logger;
    constructor(config?: Partial<ClientConfig>, options?: HatchetClientOptions);
    static with_host_port(host: string, port: number, config?: Partial<ClientConfig>, options?: HatchetClientOptions): HatchetClient;
    static init(config?: Partial<ClientConfig>, options?: HatchetClientOptions): HatchetClient;
    run(workflow: string | Workflow): Promise<Worker>;
    worker(workflow: string | Workflow): Promise<Worker>;
}
