import type { CallContext, CallOptions } from "nice-grpc-common";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "";
export interface Event {
    /** the tenant id */
    tenantId: string;
    /** the id of the event */
    eventId: string;
    /** the key for the event */
    key: string;
    /** the payload for the event */
    payload: string;
    /** when the event was generated */
    eventTimestamp: Date | undefined;
}
export interface PushEventRequest {
    /** the key for the event */
    key: string;
    /** the payload for the event */
    payload: string;
    /** when the event was generated */
    eventTimestamp: Date | undefined;
}
export interface ListEventRequest {
    /** (optional) the number of events to skip */
    offset: number;
    /** (optional) the key for the event */
    key: string;
}
export interface ListEventResponse {
    /** the events */
    events: Event[];
}
export interface ReplayEventRequest {
    /** the event id to replay */
    eventId: string;
}
export declare const Event: {
    encode(message: Event, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Event;
    fromJSON(object: any): Event;
    toJSON(message: Event): unknown;
    create(base?: DeepPartial<Event>): Event;
    fromPartial(object: DeepPartial<Event>): Event;
};
export declare const PushEventRequest: {
    encode(message: PushEventRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PushEventRequest;
    fromJSON(object: any): PushEventRequest;
    toJSON(message: PushEventRequest): unknown;
    create(base?: DeepPartial<PushEventRequest>): PushEventRequest;
    fromPartial(object: DeepPartial<PushEventRequest>): PushEventRequest;
};
export declare const ListEventRequest: {
    encode(message: ListEventRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ListEventRequest;
    fromJSON(object: any): ListEventRequest;
    toJSON(message: ListEventRequest): unknown;
    create(base?: DeepPartial<ListEventRequest>): ListEventRequest;
    fromPartial(object: DeepPartial<ListEventRequest>): ListEventRequest;
};
export declare const ListEventResponse: {
    encode(message: ListEventResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ListEventResponse;
    fromJSON(object: any): ListEventResponse;
    toJSON(message: ListEventResponse): unknown;
    create(base?: DeepPartial<ListEventResponse>): ListEventResponse;
    fromPartial(object: DeepPartial<ListEventResponse>): ListEventResponse;
};
export declare const ReplayEventRequest: {
    encode(message: ReplayEventRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ReplayEventRequest;
    fromJSON(object: any): ReplayEventRequest;
    toJSON(message: ReplayEventRequest): unknown;
    create(base?: DeepPartial<ReplayEventRequest>): ReplayEventRequest;
    fromPartial(object: DeepPartial<ReplayEventRequest>): ReplayEventRequest;
};
export type EventsServiceDefinition = typeof EventsServiceDefinition;
export declare const EventsServiceDefinition: {
    readonly name: "EventsService";
    readonly fullName: "EventsService";
    readonly methods: {
        readonly push: {
            readonly name: "Push";
            readonly requestType: {
                encode(message: PushEventRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): PushEventRequest;
                fromJSON(object: any): PushEventRequest;
                toJSON(message: PushEventRequest): unknown;
                create(base?: DeepPartial<PushEventRequest>): PushEventRequest;
                fromPartial(object: DeepPartial<PushEventRequest>): PushEventRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                encode(message: Event, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Event;
                fromJSON(object: any): Event;
                toJSON(message: Event): unknown;
                create(base?: DeepPartial<Event>): Event;
                fromPartial(object: DeepPartial<Event>): Event;
            };
            readonly responseStream: false;
            readonly options: {};
        };
        readonly list: {
            readonly name: "List";
            readonly requestType: {
                encode(message: ListEventRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): ListEventRequest;
                fromJSON(object: any): ListEventRequest;
                toJSON(message: ListEventRequest): unknown;
                create(base?: DeepPartial<ListEventRequest>): ListEventRequest;
                fromPartial(object: DeepPartial<ListEventRequest>): ListEventRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                encode(message: ListEventResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): ListEventResponse;
                fromJSON(object: any): ListEventResponse;
                toJSON(message: ListEventResponse): unknown;
                create(base?: DeepPartial<ListEventResponse>): ListEventResponse;
                fromPartial(object: DeepPartial<ListEventResponse>): ListEventResponse;
            };
            readonly responseStream: false;
            readonly options: {};
        };
        readonly replaySingleEvent: {
            readonly name: "ReplaySingleEvent";
            readonly requestType: {
                encode(message: ReplayEventRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): ReplayEventRequest;
                fromJSON(object: any): ReplayEventRequest;
                toJSON(message: ReplayEventRequest): unknown;
                create(base?: DeepPartial<ReplayEventRequest>): ReplayEventRequest;
                fromPartial(object: DeepPartial<ReplayEventRequest>): ReplayEventRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                encode(message: Event, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Event;
                fromJSON(object: any): Event;
                toJSON(message: Event): unknown;
                create(base?: DeepPartial<Event>): Event;
                fromPartial(object: DeepPartial<Event>): Event;
            };
            readonly responseStream: false;
            readonly options: {};
        };
    };
};
export interface EventsServiceImplementation<CallContextExt = {}> {
    push(request: PushEventRequest, context: CallContext & CallContextExt): Promise<DeepPartial<Event>>;
    list(request: ListEventRequest, context: CallContext & CallContextExt): Promise<DeepPartial<ListEventResponse>>;
    replaySingleEvent(request: ReplayEventRequest, context: CallContext & CallContextExt): Promise<DeepPartial<Event>>;
}
export interface EventsServiceClient<CallOptionsExt = {}> {
    push(request: DeepPartial<PushEventRequest>, options?: CallOptions & CallOptionsExt): Promise<Event>;
    list(request: DeepPartial<ListEventRequest>, options?: CallOptions & CallOptionsExt): Promise<ListEventResponse>;
    replaySingleEvent(request: DeepPartial<ReplayEventRequest>, options?: CallOptions & CallOptionsExt): Promise<Event>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
